Description

Originally I wanted to raise a bug about the markdown formatter wrongly interpreting a list sub item as code, because it ignored the

double identation instead of single identation for code in lists.

But while building a proper example to reproduce the behavior easily I found that the whole list parsing (for both ordered and

unordered lists) is borked.

While I would like to be able to provide exact directions to what exactly is wrong here, the more I played around with this, the more

confused I got.

What I can tell for almost certain is that blank lines are at the core of this issue. Normally items should be wrapped in <p> tags when

seperated by blank lines, but here (at least for unordered list items in ordered list items) instead the current ordered list is interpreted

as ended and a new ordered list started.

I used the official syntax from https://daringfireball.net/projects/markdown/syntax#list as reference, which describes behavior

conflicting with what Redmine produces currently.

Example Markup

1.  this is a list item with two child items.

    -  first child

    -  second child wrongly interpreted as code

1.   another item in the same list.

-  text wrongly interpreted as ordered list item

1. last item of the ordered list

 Expected Output (taken form Marxico)

 correct.JPG 

Output from Redmine's inbuilt Markup Parser

 wrong.JPG 

Related issues:

Related to Redmine - Feature #32424: CommonMark Markdown Text Formatting Closed

History

#1 - 2018-03-21 12:27 - Martin von Wittich

Still reproducible on 3.4.2.

#2 - 2018-03-31 11:19 - Marius BĂLTEANU

- File output.png added

- File expected_m.png added

#3 - 2018-03-31 11:19 - Marius BĂLTEANU

- Status changed from New to Needs feedback
https://daringfireball.net/projects/markdown/syntax#list


#4 - 2018-03-31 11:29 - Marius BĂLTEANU

- File deleted (output.png)

#5 - 2018-03-31 11:29 - Marius BĂLTEANU

- File deleted (expected_m.png)

#6 - 2018-03-31 11:42 - Marius BĂLTEANU

- File expected_m.png added

- Status changed from Needs feedback to Confirmed

The real issue here is that the "-  text wrongly interpreted as ordered list item" is interpreted as ordered list item instead of unordered. I'm going to

report this issue to the redcarpet gem team because is not generated by Redmine.

Regarding the "    -  second child wrongly interpreted as code" it not quite an issue because of the blank line that precedes this line and the same

behaviour is also on the marxico.

 expected_m.png 

#7 - 2018-03-31 13:11 - Marius BĂLTEANU

Marius BALTEANU wrote:

I'm going to report this issue to the redcarpet gem team because is not generated by Redmine.

 https://github.com/vmg/redcarpet/issues/655

#8 - 2022-01-22 10:52 - Marius BĂLTEANU

- File parse_lists.png added

- Status changed from Confirmed to Closed

- Resolution set to Fixed

The current Markdown implementation based on RedCarpet is deprecated, it is going to be dropped in the future versions and it will be replaced by

the CommonMark Markdown (Github Flavoured) formatter that is available in Redmine 5.0.0 (#32424).

To fix this issue, you should migrate to the new engine which correctly parses the lists:

 parse_lists.png 

#9 - 2022-01-22 10:52 - Marius BĂLTEANU

- Related to Feature #32424: CommonMark Markdown Text Formatting added

#10 - 2022-01-22 10:55 - Marius BĂLTEANU

- File deleted (parse_lists.png)

#11 - 2022-01-22 10:56 - Marius BĂLTEANU

- File parse_lists.png added

Files

correct.JPG 20.3 KB 2015-11-08 Anonymous

wrong.JPG 25 KB 2015-11-08 Anonymous

expected_m.png 187 KB 2018-03-31 Marius BĂLTEANU

parse_lists.png 49.1 KB 2022-01-22 Marius BĂLTEANU
